// Copyright (C) Thorsten Thormaehlen, Marburg, 2016, All rights reserved
// Contact: www.thormae.de

// This software is written for educational (non-commercial) purpose.
// There is no warranty or other guarantee of fitness for this software,
// it is provided solely "as is".

var stopRefresh = true;

var wids = new Array("#pageEntry", "#pageVote", "#pageCreate", "#pageFeedbackAudience", "#pageFeedbackLecturer", "#pageHelp");
function showWidget(id) {
  for (var i = 0; i < wids.length; i++) {
    if (i === id) {
      $(wids[i]).removeClass("hidden");
    } else {
      $(wids[i]).addClass("hidden"); // commenting this line is useful for debugging
    }
  }
  if (id !== 4)
    stopRefresh = true;
}

function createPoll() {

  var poll = $("#pollNumberCreate").val();
  var answers = $("#answersNumberCreate").val();

  $("#createError").html("");
  var pollInt = parseInt(poll);
  if (!pollInt || pollInt <= 0 || isNaN(pollInt)) {
    $("#createError").html("Please enter a valid poll number");
    return;
  }
  var answersInt = parseInt(answers);
  if (!answersInt || answersInt <= 1 || answersInt > 20 || isNaN(answersInt)) {
    $("#createError").html("Number of answer options must be in the range 2 to 20");
    return;
  }

  $.ajax({
    url: "clicker.php",
    type: "post",
    data: "pollNumber=" + pollInt.toString() + "&answersNumber=" + answers + "&requestType=1",
    success: function (response) {
      if (response === "Success") {
        $("#createError").html("");
        stopRefresh = false;
        giveFeedback();
      } else {
        $("#createError").html(response);
      }
    },
    error: function (response) {
      $("#createError").html('Error:' + response);
    }
  });
}

function giveFeedback() {
  var poll = $("#pollNumberCreate").val();
  $("#feedbackPollNo").html(poll);
  var pollInt = parseInt(poll);
  if (!pollInt || pollInt <= 0 || isNaN(pollInt)) {
    $("#votePrepareError").html("Please enter a valid poll number");
    return;
  }
  if (stopRefresh)
    return;
  showWidget(4);
  $.ajax({
    url: "clicker.php",
    type: "post",
    data: "pollNumber=" + pollInt.toString() + "&answersNumber=1&requestType=2",
    success: function (response) {
      var good = false;



      var splitResponse = response.split(":");
      if (splitResponse.length === 2) {
        if (splitResponse[0] === "Success") {
          var results = splitResponse[1].split(" ");
          if (results.length > 1) {
            var html = "";
            good = true;
            var total = parseInt(results[0])
            for (var i = 1; i < results.length; i++) {
              //html += ;
              var percent = 0;
              if (total > 0) {
                percent = 100 * parseInt(results[i]) / total;
              }
              html += "<div class='answerFrame'> <div class='answerBar answerColor" + i % 10 + "' +  style='width:" + percent.toFixed(2) + "%;'></div> <div class='answerNumber'>" + i + ":</div> <div class='answerPercent'>" + percent.toFixed(1) + "&#37;</div></div>";
            }
            if (!stopRefresh) {
              html += "<div class='smallTopMargin'>This page updates automatically every two seconds.</div>";
              setTimeout(giveFeedback, 2000);
            }
            $("#feedbackLecturerContent").html(html);
          }
        }
      }
      if (!good) {
        $("#feedbackLecturerError").html(response);
        $("#feedbackLecturerContent").html("");
      } else {
        $("#feedbackLecturerError").html("");
      }
    },
    error: function (response) {
      $("#feedbackLecturerError").html('Error:' + response);
    }
  });
}

function prepareVoting() {
  var poll = $("#pollNumber").val();
  var pollInt = parseInt(poll);
  if (!pollInt || pollInt <= 0 || isNaN(pollInt)) {
    $("#votePrepareError").html("Please enter a valid poll number");
    return;
  }
  $.ajax({
    url: "clicker.php",
    type: "post",
    data: "pollNumber=" + pollInt.toString() + "&answersNumber=1&requestType=3",
    success: function (response) {
      var good = false;

      var splitResponse = response.split(":");
      if (splitResponse.length === 2) {
        if (splitResponse[0] === "Success") {
          var n = parseInt(splitResponse[1]);
          if (!isNaN(n)) {
            good = true;
            var html = "";
            for (var i = 1; i < n + 1; i++) {
              html += "<div class='answer answerColor" + i % 10 + "' +  onClick='vote(" + i + ")'>" + i + "</div>";
            }
            $("#pageVoteContent").html(html);
            showWidget(1);
          }
        }
      }
      if (!good) {
        $("#votePrepareError").html(response);
        $("#pageVoteContent").html("");
      } else {
        $("#votePrepareError").html("");
      }
    },
    error: function (response) {
      $("#votePrepareError").html('Error:' + response);
    }
  });
}

function vote(val) {
  var poll = $("#pollNumber").val();
  var pollInt = parseInt(poll);
  if (!pollInt || pollInt <= 0 || isNaN(pollInt)) {
    $("#voteError").html("Please enter a valid poll number");
    return;
  }
  $.ajax({
    url: "clicker.php",
    type: "post",
    data: "pollNumber=" + pollInt.toString() + "&answersNumber=" + val + "&requestType=4",
    success: function (response) {
      var good = false;

      var splitResponse = response.split(":");
      if (splitResponse.length === 2) {
        if (splitResponse[0] === "Success") {
          good = true;
          showWidget(3);
        }
      }
      if (!good) {
        $("#voteError").html(response);
      } else {
        $("#voteError").html("");
      }
    },
    error: function (response) {
      $("#voteError").html('Error:' + response);
    }
  });
}

$(function () {
  $("#vote").button().click(prepareVoting);
  $("#admin").button().click(function () {
    showWidget(2);
  });
  ;
  $(".help").button().click(function () {
    showWidget(5);
  });
  $(".back").button().click(function () {
    showWidget(0);
  });

  $("#create").button().click(createPoll);

  $("#open").button().click(function () {
    stopRefresh = false;
    giveFeedback();
  });

  $("#pollNumberCreate").val(Math.floor(Math.random() * 8000 + 1000));

  var paramStr = decodeURIComponent(window.location.search).substring(1);
  var paramParts = paramStr.split('&');
  for (var i = 0; i < paramParts.length; i++) {
    var param = paramParts[i].split('=');
    if (param.length === 2 && param[0] === "poll") {
      var no = parseInt(param[1]);
      if (!isNaN(no)) {
        $("#pollNumber").val(param[1]);
      }
    }
  }
});